program RomanNumeralsTest;

{$IFNDEF TESTINSIGHT}
{$APPTYPE CONSOLE}
{$ENDIF}{$STRONGLINKTYPES ON}

{$R 'DelphiSpecI18n.res' '..\DelphiSpec\Source\DelphiSpecI18n.rc'}        // <--  important!

uses
  System.SysUtils,
  {$IFDEF TESTINSIGHT}
  TestInsight.DUnitX,
  {$ENDIF }
  DUnitX.Loggers.Console,
  DUnitX.Loggers.Xml.NUnit,
  DUnitX.TestFramework,
  uRomanNumeralsTest in 'uRomanNumeralsTest.pas',
  DelphiSpec.Core in '..\DelphiSpec\Source\DelphiSpec.Core.pas',
  DelphiSpec.Scenario in '..\DelphiSpec\Source\DelphiSpec.Scenario.pas',
  DelphiSpec.StepDefinitions in '..\DelphiSpec\Source\DelphiSpec.StepDefinitions.pas',
  DelphiSpec.DUnitX in '..\DelphiSpec\Source\DelphiSpec.DUnitX.pas',
  DelphiSpec.Attributes in '..\DelphiSpec\Source\DelphiSpec.Attributes.pas',
  DelphiSpec.DataTable in '..\DelphiSpec\Source\DelphiSpec.DataTable.pas',
  DelphiSpec.Parser in '..\DelphiSpec\Source\DelphiSpec.Parser.pas',
  DelphiSpec.Assert in '..\DelphiSpec\Source\DelphiSpec.Assert.pas';

var
  runner : ITestRunner;
  results : IRunResults;
  logger : ITestLogger;
  nunitLogger : ITestLogger;

  Features: TFeatureList;
begin
{$IFDEF TESTINSIGHT}
  TestInsight.DUnitX.RunRegisteredTests;
  exit;
{$ENDIF}
  Features := ReadFeatures(GetCurrentDir, False, 'EN');
  try
    RegisterFeaturesWithDUnitX('Mydemo', Features);

    try
      //Check command line options, will exit if invalid
      TDUnitX.CheckCommandLine;
      //Create the test runner
      runner := TDUnitX.CreateRunner;
      //Tell the runner to use RTTI to find Fixtures
      runner.UseRTTI := True;
      //tell the runner how we will log things
      //Log to the console window
      logger := TDUnitXConsoleLogger.Create(true);
      runner.AddLogger(logger);
      //Generate an NUnit compatible XML File
      nunitLogger := TDUnitXXMLNUnitFileLogger.Create(TDUnitX.Options.XMLOutputFile);
      runner.AddLogger(nunitLogger);
      runner.FailsOnNoAsserts := False; //When true, Assertions must be made during tests;

      //Run tests
      results := runner.Execute;
      if not results.AllPassed then
        System.ExitCode := EXIT_ERRORS;

      {$IFNDEF CI}
      //We don't want this happening when running under CI.
      if TDUnitX.Options.ExitBehavior = TDUnitXExitBehavior.Pause then
      begin
        System.Write('Done.. press <Enter> key to quit.');
        System.Readln;
      end;
      {$ENDIF}
    except
      on E: Exception do
        System.Writeln(E.ClassName, ': ', E.Message);
    end;

  finally
    Features.Free;
  end;
end.
